<template>
    <v-dialog
      v-model="show"
      width="800"
      :disabled="disabled"
      fullscreen
      hide-overlay
      transition="dialog-bottom-transition"
    >
    <v-overlay :opacity="0.8">
      <v-container container--fluid fill-height>
        <v-layout align-center justify-center>
          <v-flex xs12 s12 md6 lg6 xl2>
            <v-card class="elevation-12">
              <v-card-text>
                <v-layout row wrap>

                  <v-form @submit.prevent>
                    <v-container fluid>
                      <v-row align="center">
                        <v-col cols="12">
                          <v-alert
                            color="error"
                            dark
                            :value="error != ''"
                            icon="warning"
                            transition="fade-transition"
                            >{{ error }}</v-alert
                          >
                        </v-col>
                        <v-col cols="12">
                          <div class="otp-input-wrapper">
                            <v-otp-input
                              ref="otpInput"
                              input-classes="otp-input"
                              separator="-"
                              :num-inputs="otp_code_length"
                              :should-auto-focus="true"
                              :is-input-num="true"
                              @on-change="handleOnChange"
                              @on-complete="handleOnComplete"
                            />
                          </div>
                        </v-col>
                        <v-col cols="12">
                          <v-layout align-center class="mt-4">
                            <v-flex xs12 text-center>
                              <p>
                                Resend otp code?
                              </p>
                            </v-flex>
                          </v-layout>
                        </v-col>

                        <v-col cols="12">
                          <v-layout align-center class="mt-4">
                            <v-flex xs12 text-center>
                              <v-btn
                                :loading="email_loading"
                                :disabled="email_loading || resend_loading || verify_loading"
                                color="primary"
                                type="submit"
                                @click="resend(via.EMAIL)"
                                name="resend-button"
                                >
                                  <v-icon dark small>mdi-email</v-icon>Email
                                </v-btn>
                              <v-btn
                                :loading="resend_loading"
                                color="primary"
                                :disabled="resend_loading || email_loading || verify_loading"
                                type="submit"
                                @click="resend(via.NEXMO)"
                                name="resend-button"
                                >
                                  <v-icon dark small>mdi-message-text</v-icon>SMS
                                </v-btn>
                            </v-flex>
                          </v-layout>
                        </v-col>

                      </v-row>
                    </v-container>
                  </v-form>
                </v-layout>
              </v-card-text>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </v-overlay>

  </v-dialog>
</template>

<style>
  .otp-input-wrapper {
    display: flex;
    flex-direction: row;
    justify-content: center;
  }
  .otp-input {
    width: 40px;
    height: 40px;
    padding: 5px;
    margin: 0 10px;
    font-size: 20px;
    border-radius: 4px;
    border: 1px solid rgb(255, 255, 255);
    text-align: center;
    &.error {
      border: 1px solid red !important;
    }
  }
  .otp-input::-webkit-inner-spin-button,
  .otp-input::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }
</style>

<script>
import CONSTANTS from '../../../constants';
import OtpInput from "@bachdgvn/vue-otp-input";

const DEFAULT_OTP_VIA = {
  EMAIL: 0,
  NEXMO: 1
};

const DEFAULT_OTP_STATUS = {
  SUCCESS:                'success',
  STATUS_READY:           'ready',
  STATUS_VERIFIED:        'verified',
  STATUS_VALID_OTP:       'valid_otp',
  STATUS_INVALID_OTP:     'invalid_otp',
  STATUS_EXPIRED_OTP:     'expired_otp',
  STATUS_ALREADY_VERFIED: 'already_verified',
  OTP_DISABLED:           'otp_disabled'

};

export default {
  name: 'AuthLoginOtp',

  components: {
    'v-otp-input': OtpInput,
  },

  props: {
    password: {
      default: '',
      type: String
    },
    disabled: {
      default: false,
      type: Boolean
    },
    email: {
      default: null,
      type: String
    },
    phone: {
      default: null,
      type: String
    },
    otp_length: {
      default: 4,
      type: Number
    },
    for_activation: {
      default: false,
      type: Boolean
    }
  },

  computed: {
  },

  watch: {
  },

  data: () => {
    return {
      via: Object.assign({},DEFAULT_OTP_VIA),
      error: '',
      verify_loading: false,
      resend_loading: false,
      email_loading: false,
      show: false,
      otp_code: null,
      otp_code_length: 4,
      send_otp_via: null,
      pass_status: [
        DEFAULT_OTP_STATUS.STATUS_VERIFIED,
        DEFAULT_OTP_STATUS.STATUS_VALID_OTP,
        DEFAULT_OTP_STATUS.OTP_DISABLED,
        DEFAULT_OTP_STATUS.STATUS_ALREADY_VERFIED,
      ],
      otp_data: {},
    };
  },

  mounted() {
    this.otp_code_length = this.otp_length;
    this.setOtpVia(DEFAULT_OTP_VIA.EMAIL);
    this.initOtpLength();
    console.log(this.$refs);
    console.log('aut-login-otp:mounteds');
  },

  methods: {
    /**
     * Initializes the otp length.
     */
    initOtpLength() {
      this.$http
        .get('/auth/otp/length')
        .then(res => {
            this.otp_code_length = parseInt(res.data.otp_length);
        })
        .catch(err => {
            console.warn(err);
            this.otp_code_length = 4;
        });
    },

    triggerShow() {
      this.error = '';
      this.show = true;
    },

    handleOnComplete(value) {
      console.log('OTP completed: ', value);
      this.otp_code = value;
      if (this.for_activation) {
        this.activate();
      } else {
        this.verify();
      }
    },

    handleOnChange(value) {
      console.log('OTP changed: ', value);
    },

    handleClearInput() {
      if (this.$refs.otpInput) {
        this.$refs.otpInput.clearInput();
      }
    },

    /**
     * Cancel Edit just hide the popup component
     */
    cancelEdit() {
        this.show = false;
    },

    setOtpVia(via) {
      this.send_otp_via = via;
    },

    getOtpVia() {
      return this.send_otp_via;
    },

    _parseOtpData(result) {
      if (!result.hasOwnProperty('response')) {

        /**
         * backward compatibility, some versions of axios returns different
         * structure of response
         */
        if (result.hasOwnProperty('data')) {
          this.otp_data = result.data;
          this._syncStatus();
          return this;
        }

        this.otp_data = {};
        return this;
      }
      if (!result.response.hasOwnProperty('data')) {
        this.otp_data = {};
        return this;
      }

      this.otp_data = result.response.data;
      this._syncStatus();
      return this;
    },

    _syncStatus() {
      var data = this.getOtpData();
      if (!data.hasOwnProperty('otp_status')) {
        this.otp_data.otp_status = false;
      }
    },

    getOtpMessage() {
      var data = this.getOtpData();
      if (!data.hasOwnProperty('message')) {
        return '';
      }
      return data.message;
    },

    getOtpStatus() {
      var data = this.getOtpData();
      if (!data.hasOwnProperty('otp_status')) {
        return false;
      }
      return data.otp_status;
    },

    getOtpData() {
      return this.otp_data;
    },

    _isStatusPassed() {
      var status = this.getOtpStatus();
      return this.pass_status.includes(status);
    },

    _isStatusReady() {
      var status = this.getOtpStatus();
      return status == DEFAULT_OTP_STATUS.STATUS_READY;
    },

    _isStatusSuccess() {
      var status = this.getOtpStatus();
      return status == DEFAULT_OTP_STATUS.SUCCESS;
    },

    _requestCatch(result) {

      console.warn(result);
      this._parseOtpData(result);

      if (this._isStatusPassed()) {
        this.emitOnLogin();
        return true;
      }

      var otp_data = this.getOtpData();
      if (result.response && result.response.status === 429) {
        try {
          this.error = otp_data.errors.email[0];
        } catch (err) {
          this.error = 'Too many login attempts';
        }
      }

      this.emitError();
    },

    _requestFinally() {
      this.resend_loading = false;
      this.email_loading  = false;
      this.verify_loading = false;
      this.handleClearInput();
    },

    _swalMessage(message, icon) {
      if (typeof icon == 'undefined') {
        icon = 'success';
      }

      swal({
          title: 'One-Time Password',
          text:  message,
          icon:  icon
      });
    },

    /**
     * Check the credential and if the user has OTP  enabled
     */
    check() {
      this.verify_loading = true;
      this.$validator.validate().then(result => {
        this.$http
          .post('/auth/otp/check', {
            password: this.password,
            email:    this.email,
          })
          .then(res => {
            this._parseOtpData(res);
            if (this._isStatusReady()) {
              this.triggerShow();
              return true;
            }
            if (this._isStatusPassed()) {
              this.emitOnLogin();
              return true;
            }
            this.emitError();
          })
          .catch(this._requestCatch)
          .finally(this._requestFinally);
        });
    },

    /**
     * Verify OTP code
     */
    verify() {
      this.verify_loading = true;
      this.$http
        .post('/auth/otp/verify', {
            password: this.password,
            email:    this.email,
            code:     this.otp_code,
        })
        .then(res => {
          this._parseOtpData(res);
          if (this._isStatusPassed()) {
            this._swalMessage('OTP succesfully verified');
            this.emitOnLogin();
            return true;
          }
          this.emitError();
        })
        .catch(this._requestCatch)
        .finally(this._requestFinally);
    },

    /**
     * Re-send the OTP Code
     *
     * IN PROGERSS
     */
    resend(mode) {

      this.setOtpVia(mode);

      var url = '';

      if (this.getOtpVia() == DEFAULT_OTP_VIA.EMAIL) {
        url = '/auth/otp/' + 'email';
        this.email_loading = true;
      } else {
        url = '/auth/otp/' + 'refresh';
        this.resend_loading = true;
      }

      this.$http
        .get(url + "?email=" + this.email)
        .then(result => {
          this._parseOtpData(result);
          if (result.data.success) {
            this._swalMessage(this.getOtpMessage());
            return true;
          }
          this.emitError();
        })
        .catch(this._requestCatch)
        .finally(this._requestFinally);
    },

    /**
     * Activates the given mode.
     */
    activate() {
      console.log(this.otp_code);
      this.$http
        .post('/auth/otp/activate', {
            code: this.otp_code,
        })
        .then(res => {
          console.log(res);
          this._parseOtpData(res);
          if (this._isStatusSuccess()) {
            this._swalMessage(this.getOtpMessage());
            this.emitOnLogin();
            return true;
          }
          this.emitError();
        })
        .catch(this._requestCatch)
        .finally(this._requestFinally);
    },

    /**
     * Enabled the otp for user
     */
    enable() {
      console.log(this.getOtpVia());
      this.$http
        .post('/auth/otp/enable', {
          otp_via: this.getOtpVia(),
          email: this.email,
          phone: this.phone,
        })
        .then(res => {
          console.log(res);
          this._parseOtpData(res);
          if (this._isStatusReady()) {
            this.triggerShow();
            return true;
          }
          if (this._isStatusPassed()) {
            this.emitOnLogin();
            return true;
          }
          this.emitError();
        })
        .catch(this._requestCatch)
        .finally(this._requestFinally);
    },

    /**
     * Disable the otp for user
     */
    disable() {
      this.$http
        .post('/auth/otp/disable')
        .then(res => {
          this._parseOtpData(res);
          if (this._isStatusSuccess()) {
            this._swalMessage(this.getOtpMessage());
            this.emitOnLogin();
          } else {
            console.log('otp disable problem', res);
          }
        })
        .catch(this._requestCatch)
        .finally(this._requestFinally);
    },

    emitOnLogin() {
      var otp_data = this.getOtpData();
      this.$emit('on-login', otp_data);
      this.show = false;
    },

    /**
     * Emit verified to the parent vue layout
     *
     * @param      {object}  res     The resource
     */
    emitVerified(res) {
        var otp_data = this.getOtpData();
        if (otp_data.otp_status == 'valid_otp') {
            // emit item
            swal({
                title: 'OTP Code',
                text: 'OTP succesfully verified',
                icon: 'success'
            });
        }
        this.$emit('on-verified', otp_data);
        this.show = false;
    },

    /**
     * Emit Resend to the parent vue layout
     */
    emitResend() {
        // emit item
        var otp_data = this.getOtpData();
        this.handleClearInput();
        swal({
            title: 'OTP Code',
            text: this.getOtpMessage(),
            icon: 'success'
        });
        this.$emit('on-resend', otp_data);
        this.show = false;
    },

    emitError() {
      var otp_data = this.getOtpData();
      this.handleClearInput();
      this._swalMessage(this.getOtpMessage(), 'error');
      this.$emit('on-error', otp_data);
      this.show = false;
    },

    /**
     * END METHOD
     */
  }
  /**
   * END DEFAULT
   */
};

</script>
